#!/usr/bin/perl -w

my @langs = ('de','fr','es','cz','hu');
my @test_sets = ('newstest2009');

my $combinedJudgmentsFile = $ARGV[0];

print "\t";
print `cat $combinedJudgmentsFile | grep $langs[0]-en |  perl generate-table.perl | grep -v n/a | perl spearmans-rank.perl | head -2 | tail -1`;
foreach my $src_lang (@langs) {
    print "$src_lang-en (";
    my $numSystems = `cat $combinedJudgmentsFile | grep $src_lang-en |  perl generate-table.perl | grep -v n/a | wc -l`;
    $numSystems =~ s/\s//g;
    $numSystems = $numSystems -2;
    print "$numSystems systems)\t";
    $numMetrics = `cat $combinedJudgmentsFile | grep $src_lang-en |  perl generate-table.perl | head -2 | tail -1 | wc -w`;
    $numMetrics =~ s/\s//g;
    
    @rankedSystems = `cat $combinedJudgmentsFile | grep $src_lang-en | perl generate-table.perl | tail -$numSystems | sort -nr -k2 | cut -f1`;
    chomp @rankedSystems;
    for($i = 2; $i < $numMetrics+2; $i++) {
	@otherRanks = `cat $combinedJudgmentsFile | grep $src_lang-en | perl generate-table.perl | tail -$numSystems | sort -nr -k$i | cut -f1`;
	chomp @otherRanks;

	for($j = 0; $j < @rankedSystems; $j++) {
	    $rankHasChanged = 0;
	    if(!($rankedSystems[$j] eq $otherRanks[$j])) {
		print ($j+1);
		print "\t";
		$j=@rankedSystems;
		$rankHasChanged = 1;
	    }
	}
	if($rankHasChanged == 0) {
	    print "none\t";
	}

    }
    print "\n";

}

@langs = ('de','fr','es','cz');
print "\n\n\t";
print `cat $combinedJudgmentsFile | grep en-$langs[0] |  perl generate-table.perl | grep -v n/a | perl spearmans-rank.perl | head -2 | tail -1`;
foreach my $src_lang (@langs) {
    print "en-$src_lang (";
    my $numSystems = `cat $combinedJudgmentsFile | grep en-$src_lang |  perl generate-table.perl | grep -v n/a | wc -l`;
    $numSystems =~ s/\s//g;
    $numSystems= $numSystems -2;
    print "$numSystems systems)\t";

    $numMetrics = `cat $combinedJudgmentsFile | grep en-$src_lang |  perl generate-table.perl | head -2 | tail -1 | wc -w`;
    $numMetrics =~ s/\s//g;
    
    @rankedSystems = `cat $combinedJudgmentsFile | grep en-$src_lang | perl generate-table.perl | tail -$numSystems | sort -nr -k2 | cut -f1`;
    chomp @rankedSystems;
    for($i = 2; $i < $numMetrics+2; $i++) {
	@otherRanks = `cat $combinedJudgmentsFile | grep en-$src_lang | perl generate-table.perl | tail -$numSystems | sort -nr -k$i | cut -f1`;
	chomp @otherRanks;

	for($j = 0; $j < @rankedSystems; $j++) {
	    $rankHasChanged = 0;
	    if(!($rankedSystems[$j] eq $otherRanks[$j])) {
		print ($j+1);
		print "\t";
		$j=@rankedSystems;
		$rankHasChanged = 1;
	    }
	}
	if($rankHasChanged == 0) {
	    print "none\t";
	}

    }
    print "\n";

}
